﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  
  [StorableClass]
  [DataContract]
  public class AppointmentDto: PersistableObject {
    [Storable]
    [DataMember]
    public DateTime StartDate { get; set; }
    [Storable]
    [DataMember]
    public DateTime EndDate { get; set; }
    [Storable]
    [DataMember]
    public bool AllDayEvent { get; set; }
    [Storable]
    [DataMember]
    public bool Recurring { get; set; }
    [Storable]
    [DataMember]
    public Guid RecurringId { get; set; }
    [Storable]
    [DataMember]
    public Guid ResourceId { get; set; }

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      AppointmentDto clone = (AppointmentDto)base.Clone(cloner);
      clone.AllDayEvent = this.AllDayEvent;
      clone.EndDate = this.EndDate;
      clone.Recurring = this.Recurring;
      clone.RecurringId = this.RecurringId;
      clone.ResourceId = this.ResourceId;
      clone.StartDate = this.StartDate;
      return clone;
    }
  }
}
