﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Collections;
using HeuristicLab.Common;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {
  public class SlaveGroupDtoList : ObservableList<SlaveGroupDto>, IDeepCloneable {

    public SlaveGroupDtoList() { }
    public SlaveGroupDtoList(IEnumerable<SlaveGroupDto> collection) {
      this.list = new List<SlaveGroupDto>(collection);
    }

    [StorableConstructor]
    protected SlaveGroupDtoList(bool deserializing) : base(deserializing) { }

    public object Clone() {
      return Clone(new Cloner());
    }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      SlaveGroupDtoList clone = (SlaveGroupDtoList)Activator.CreateInstance(this.GetType());
      cloner.RegisterClonedObject(this, clone);
      clone.list = (this.Select(x => (SlaveGroupDto)cloner.Clone(x))).ToList();
      return clone;
    }
  }
}
